<?php
/**************************************************
	Пример использования:

	{exp:menu_builder:show  alias="main_menu"}
	{menu_list}
	{/exp:menu_builder:show}
***************************************************/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class menu_builder {
	
	function show()
	{
		global $DSP, $DB, $TMPL;
		
		// Входящие переменные
		if ( ! $alias = $TMPL->fetch_param('alias'))  // Короткое название меню
        {
        	return '';
        }
		if ( ! $class = $TMPL->fetch_param('class'))  // Класс меню ( <ul class> )
        {
        	$class = "";
        }
        if ( ! $id = $TMPL->fetch_param('id'))        // ID меню ( <ul id> )
        {
        	$id = "";
        }

		if ( ! $li_class = $TMPL->fetch_param('li_class'))  // Класс пункта ( <li class> )
        {
        	$li_class = "";
        }
        if ( ! $li_id = $TMPL->fetch_param('li_id'))        // ID пункта ( <li id> )
        {
        	$li_id = "";
        }
        if ( ! $rightadd = $TMPL->fetch_param('rightadd'))        // ID пункта ( <li id> )
        {
        	$rightadd = "";
        }
		if ( ! $select = $TMPL->fetch_param('select'))        // ID пункта ( <li id> )
        {
        	$select = "";
        }
		if ( ! $select_class = $TMPL->fetch_param('select_class'))        // ID пункта ( <li id> )
        {
        	$select_class = "";
        }
		
		//
		$res = Array(); //  -  Полученные данные с баз
		
		// Получение текущего меню с БД
        $sql = "SELECT menu_id, 
			           menu_name
					FROM exp_menu_builder WHERE `menu_alias`='$alias'";			
		$menu = $DB->query($sql);
		if ($menu->num_rows == 0) return '';  //  Если меню не найдено - выходим
		$menu = $menu->row;
		$res["menu_name"] = $menu['menu_name'];
		
		// Получение пунктов меню с БД
        $sql = "SELECT link_num,
        			   link_id, 
			           link_text,
			           link_title,
			           link_href
					FROM exp_menu_builder_links WHERE `menu_id`='{$menu['menu_id']}'";			
		$link = $DB->query($sql);
		$link = $link->result;
		sort($link);  // Сортировка пунктов
		
		// Вывод меню
		$res["menu_list"] = "\n<!-- Меню : {$res["menu_name"]} -->";   // Коммент меню
		$res["menu_list"] .= "\n<ul";
		if ($id != "") $res["menu_list"] .= " id=\"$id\""; 
		if ($class != "") $res["menu_list"] .= " class=\"$class\"";
		$res["menu_list"] .= ">";
		
		$select = str_replace("&#47;","/",$select);
		foreach ($link as $key => $val)
		{
			$res["menu_list"] .= "\n   <li";
			if ($li_id != "") $res["menu_list"] .= " id=\"$li_id\""; 
			
			if( $select_class != "" && stristr( $val["link_href"], $select ) )
			{
				$res["menu_list"] .= " class=\"$select_class\"";
			}
			elseif ($li_class != "")
			{
				$res["menu_list"] .= " class=\"$li_class\"";
			}

			$res["menu_list"] .= "><a href='{$val["link_href"]}$rightadd'";
			if ($val["link_title"] != "") $res["menu_list"] .= " title='{$val["link_title"]}'";
			$res["menu_list"] .= ( $select != "" && $select_class == "" && stristr($val["link_href"],$select) ) ? "><b>{$val["link_text"]}</b></a></li>":">{$val["link_text"]}</a></li>";
		}
		$res["menu_list"] .= "\n</ul>";
		
		foreach ($res as $key=>$var)
		{
			$TMPL->tagdata = str_replace(LD.$key.RD, $var, $TMPL->tagdata);
		}
		
		return $TMPL->tagdata;
	}
}
?>